
   import external.viewer.*;


    public class java__lang__Double_DoubleView extends FloatView {
    
       public java__lang__Double_DoubleView() {
         super(63, 62, 52, 51, 0, 1023);
      }
   
       public int getPriority() {
         return 10; }
   
       public String getValueText(Value value, DebugContext context)
            throws ViewerException {
         return Double.toString(getValue_(value, context));
      }
      
       public long getBits(Value value, DebugContext context)
            throws ViewerException {
         return Double.doubleToRawLongBits(getValue_(value, context));
      }
   
       public String getMantissaText(double mantissa) {
         return Double.toString(mantissa); }
   
       private double getValue_(Value value, DebugContext context)
            throws ViewerException {
         Method get_value_method = value.getMethod(context, "doubleValue", "double", null);
         return value.invokeMethod(context, get_value_method, null).toDouble(context);
      }
   }