
   import external.Viewer;
   import external.viewer.*;
   import java.util.ArrayList;
   import javax.swing.DefaultListModel;
   import javax.swing.JComponent;
   import javax.swing.JList;
   import javax.swing.JScrollPane;

    public class java__util__Map_ToStringView extends JScrollPane
            implements Viewer {
   
      private JList list_;
   
       public java__util__Map_ToStringView() {
         list_ = new JList(new DefaultListModel());
         setViewportView(list_);
      }
       
       public JComponent getComponent() {
         return this; }
          
       public String getName() {
         return "Key/Value toString()"; }
   
       public int getPriority() {
         return 10; }
   
       public void setFrozen() {}
   
       public void update(Value value, DebugContext context) throws ViewerException {
         DefaultListModel lm = (DefaultListModel)list_.getModel();
         lm.clear();
         
         Method entry_set_method = value.getMethod(context, "entrySet", "java.util.Set", null);
         Value entry_set = value.invokeMethod(context, entry_set_method, null);
         
         Method iterator_method = entry_set.getMethod(context, "iterator", "java.util.Iterator", null);
         Value iterator = entry_set.invokeMethod(context, iterator_method, null);
         
         Method has_next_method = iterator.getMethod(context, "hasNext", "boolean", null);
         Method next_method = iterator.getMethod(context, "next", "java.lang.Object", null);
         
         while(true) {
            if(!iterator.invokeMethod(context, has_next_method, null).toBoolean(context))
               break;
            Value next = iterator.invokeMethod(context, next_method, null);
            Value key_val = next.getFieldValue(context, "key");
            Value value_val = next.getFieldValue(context, "value");
            
            String key_str = key_val.toString(context);
            if(key_str.length() > 25)
               key_str = key_str.substring(0, 21) + " ...";
         
            String value_str = value_val.toString(context);
            if(value_str.length() > 25)
               value_str = value_str.substring(0, 21) + " ...";
         
            lm.addElement(key_str + ": " + value_str);
         }
      }
   }
