
   import external.Viewer;
   import external.viewer.*;
   import java.awt.BorderLayout;
   import java.awt.Color;
   import java.awt.Dimension;
   import javax.swing.BorderFactory;
   import javax.swing.JComponent;
   import javax.swing.JPanel;
   import javax.swing.JScrollPane;
   import javax.swing.JTextArea;

    public class java__awt__Color_ColorView extends JPanel
            implements Viewer {
   
      private JPanel colorPanel_;
      private JTextArea text_;
   
       public java__awt__Color_ColorView() {
         super(new BorderLayout());
         
         colorPanel_ = 
                new JPanel() {
                   public Dimension getPreferredSize() {
                     int ht = getFont().getSize();
                     return new Dimension(ht * 2, ht * 2);
                  }
               };
         colorPanel_.setBorder(BorderFactory.createEtchedBorder());
         add(colorPanel_, "North");
         text_ = new JTextArea();
         text_.setEditable(false);
         add(new JScrollPane(text_), "Center");
      }
       
       public JComponent getComponent() {
         return this; }
          
       public String getName() {
         return "Color"; }
   
       public int getPriority() {
         return 10; }
   
       public void setFrozen() {}
   
       public void update(Value value, DebugContext context) throws ViewerException {
         Method get_rgb_method = value.getMethod(context, "getRGB", "int", null);
         int rgb = value.invokeMethod(context, get_rgb_method, null).toInt(context);
         
         Color color = new Color(rgb);
         colorPanel_.setBackground(color);
         
         StringBuffer text = new StringBuffer();
         text.append("red = ");
         text.append(color.getRed());
         text.append("\ngreen = ");
         text.append(color.getGreen());
         text.append("\nblue = ");
         text.append(color.getBlue());
         int alpha = color.getAlpha();
         if(alpha < 255) {
            text.append("\nalpha = ");
            text.append(alpha); }
      
         text_.setText(text.toString());
      }
   
       public void updateUI() {
         super.updateUI();
         BorderLayout layout = (BorderLayout)getLayout();
         int gap = 1 + getFont().getSize() / 2;
         layout.setHgap(gap);
         layout.setVgap(gap);
         setBorder(BorderFactory.createEmptyBorder(gap, gap, gap, gap));
      }
   }
